# $Id: graphviz.spec.in,v 1.1 2005/08/13 12:58:55 ellson Exp $ $Revision: 1.1 $
# graphviz.spec.  Generated from graphviz.spec.in by configure.

# Note: graphviz requires gd with gif support (and other fixes), hence use
# internal one for now.

Summary:	Graph Visualization Tools
Name:		graphviz
Version:	2.6
Release:	1

Group:		Applications/Multimedia
License:	CPL
URL:		http://www.graphviz.org/
Source:		http://www.graphviz.org/pub/graphviz/ARCHIVE/graphviz-2.6.tar.gz

# SuSE uses a different mechanism to generate BuildRequires
# norootforbuild
# neededforbuild  expat freetype2 freetype2-devel gcc libjpeg libpng-devel-packages tcl tcl-devel tk tk-devel x-devel-packages

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	zlib-devel libpng-devel libjpeg-devel expat-devel freetype-devel >= 2
BuildRequires:	/bin/ksh bison m4 flex tk tcl >= 8.3 swig
BuildRequires:	/usr/include/tcl.h /usr/include/tk.h
%{?fc5:BuildRequires: fontconfig-devel xorg-x11-devel libtool-ltdl-devel} 
%{?fc4:BuildRequires: fontconfig-devel xorg-x11-devel libtool-ltdl-devel} 
%{?fc3:BuildRequires: fontconfig-devel xorg-x11-devel} 
%{?fc2:BuildRequires: fontconfig-devel XFree86-devel}
%{?fc1:BuildRequires: fontconfig-devel XFree86-devel}
%{?el4:BuildRequires: fontconfig-devel xorg-x11-devel}
%{?el3:BuildRequires: fontconfig-devel XFree86-devel}
%{?el2:BuildRequires: XFree86-devel}
%{?rh9:BuildRequires: XFree86-devel}
%{?rh8:BuildRequires: XFree86-devel}
%{?rh7:BuildRequires: XFree86-devel}
%{?rh6:BuildRequires: XFree86-devel}

%package tcl
Group:		Applications/Multimedia
Summary:	Tcl extension tools for %{name}
Requires:	%{name} = %{version}-%{release} tcl >= 8.3 tk

%package devel
Group:		Development/Libraries
Summary:	Development package for %{name}
Requires:	%{name} = %{version}-%{release} pkgconfig

%package doc
Group:		Documentation
Summary:	PDF and HTML documents for %{name}

%package graphs
Group:		Applications/Multimedia
Summary:	Demo graphs for %{name}


%description
A collection of tools for the manipulation and layout
of graphs (as in nodes and edges, not as in barcharts).

%description tcl
Various tcl packages (extensions) for the %{name} tools.

%description devel
A collection of tools for the manipulation and layout
of graphs (as in nodes and edges, not as in barcharts).
This package contains development files for %{name}.

%description doc
Provides some additional PDF and HTML documentation for %{name}.

%description graphs
Some demo graphs for %{name}.


%prep
%setup -q


%build
# XXX ix86 only used to have -ffast-math, let's use everywhere
%{expand: %%define optflags %{optflags} -ffast-math}
# %%configure is broken in RH7.3 rpmbuild
# need unreleased changes to gd, so use --with-mylibgd for now.
CFLAGS="$RPM_OPT_FLAGS" \
./configure \
      --prefix=%{_prefix} \
      --bindir=%{_bindir} \
      --libdir=%{_libdir} \
      --includedir=%{_includedir} \
      --datadir=%{_datadir} \
      --mandir=%{_mandir} \
      --with-x \
      --with-mylibgd \
      --disable-static \
      --disable-dependency-tracking
%__make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT __doc
%{__make} \
    DESTDIR=$RPM_BUILD_ROOT \
    docdir=$RPM_BUILD_ROOT%{_docdir}/%{name} \
    pkgconfigdir=%{_libdir}/pkgconfig \
    install
chmod -x $RPM_BUILD_ROOT%{_datadir}/%{name}/lefty/*
cp -a $RPM_BUILD_ROOT%{_datadir}/%{name}/doc __doc
rm -rf $RPM_BUILD_ROOT%{_datadir}/%{name}/doc


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING ChangeLog NEWS README
%{_bindir}/*
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/*.so.*
%{_mandir}/man1/*.1*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/lefty
%exclude %{_libdir}/%{name}/lib*tcl*.so.*
%exclude %{_libdir}/%{name}/libtk*.so.*

%files tcl
%defattr(-,root,root,-)
%{_libdir}/%{name}/lib*tcl*.so.*.*
%{_libdir}/%{name}/libtk*.so.*.*
%{_libdir}/%{name}/pkgIndex.tcl
%{_datadir}/%{name}/demo
%{_mandir}/mann/*.n*

%files devel
%defattr(-,root,root,-)
%{_includedir}/%{name}
%{_libdir}/%{name}/*.la
%{_libdir}/%{name}/*.so
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man3/*.3*
%exclude %{_libdir}/%{name}/lib*tcl*.*
%exclude %{_libdir}/%{name}/libtk*.*

%files graphs
%defattr(-,root,root,-)
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/graphs

%files doc
%defattr(-,root,root,-)
%doc __doc/*

# run "dot -c" to generate plugin config in %{_libdir}/%{name}/config
%post
%{_bindir}/dot -c

%post tcl
%{_bindir}/dot -c

%post devel
%{_bindir}/dot -c

%changelog
* Sat Aug 13 2005 John Ellson <ellson@research.att.com>
- imported various fixes from the Fedora-Extras .spec by Oliver Falk <oliver@linux-kernel.at>
* Wed Jul 20 2005 John Ellson <ellson@research.att.com>
- release 2.4
